/* $Id: MacSpi.java,v 1.1.1.1 1999/07/13 23:15:32 gelderen Exp $
 *
 * Copyright (C) 1995-1998 Systemics Ltd. 
 * on behalf of the Cryptix Development Team. All rights reserved.
 * 
 * Use, modification, copying and distribution of this software is subject 
 * the terms and conditions of the Cryptix General Licence. You should have 
 * received a copy of the Cryptix General License along with this library; 
 * if not, you can download a copy from http://www.cryptix.org/ .
 */
package javax.crypto;


import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.Key;
import java.security.spec.AlgorithmParameterSpec;


public abstract class MacSpi {
    
    protected abstract int engineGetMacLength();
    
    
    protected abstract void engineInit(Key key, AlgorithmParameterSpec params)
    throws InvalidKeyException, InvalidAlgorithmParameterException;
    
    
    protected abstract void engineUpdate(byte input);
    
    
    protected abstract void engineUpdate(byte[] input, int offset, int len);
    
    
    protected abstract byte[] engineDoFinal();
    
    
    protected abstract void engineReset();
    
    
    public java.lang.Object clone()
    throws CloneNotSupportedException {
        throw new CloneNotSupportedException();
    }
    
}
