/* $Id: SecretKeyFactorySpi.java,v 1.1.1.1 1999/07/13 23:15:32 gelderen Exp $
 *
 * Copyright (C) 1995-1998 Systemics Ltd. 
 * on behalf of the Cryptix Development Team. All rights reserved.
 * 
 * Use, modification, copying and distribution of this software is subject 
 * the terms and conditions of the Cryptix General Licence. You should have 
 * received a copy of the Cryptix General License along with this library; 
 * if not, you can download a copy from http://www.cryptix.org/ .
 */
package javax.crypto;


import java.security.InvalidKeyException;
import java.security.spec.InvalidKeySpecException;
import java.security.spec.KeySpec;


public abstract class SecretKeyFactorySpi {
    
    public SecretKeyFactorySpi() {
    }
    
    
    protected abstract SecretKey engineGenerateSecret(KeySpec keySpec)
    throws InvalidKeySpecException;
    
    
    protected abstract KeySpec engineGetKeySpec(SecretKey key, Class keySpec)
    throws InvalidKeySpecException;
    
    
    protected abstract SecretKey engineTranslateKey(SecretKey key) 
    throws InvalidKeyException;
}
